%define _with_perl 0
%define qtdir /usr/lib/qt-1.45
%define version 1.1.2
%define kderelease 37.niisi
%define sourcedir stable/%{version}/distribution/tar/generic/source

%define kdename kdebase
%define pamservice kde

Name: %{kdename}
Icon: kde-icon.xpm
URL: http://www.kde.org
Summary: Core files for the K Desktop Environment (KDE).
Version: %{version}
Release: %{kderelease}
Serial: 2
Source: ftp://ftp.kde.org/pub/kde/{sourcedir}/%{kdename}-%{version}.tar.bz2
Source1: KDE.session.gnome
Source2: Autorun.kdelnk
Patch0: kdebase-1.1.2-redhat.patch
Patch1: kdebase-1.1-waitkdm.patch
Patch2: kdebase-1.1.2-dodesktop.patch
Patch3: kdebase-1.1.2-saveoption.patch
Patch4: kdebase-1.1.2-enablepng.patch
Patch5: kdebase-1.1.2-bigendian.patch
Patch6: kdebase-glxMesa.patch
Patch7: kdebase-1.1.2-eject.patch
Patch8: kdebase-1.1.2-kfm-dir.patch
Patch9: kdebase-1.1.2-fixdebug.patch
Patch10: kdebase-1.1.2-boolterm.patch
Patch11: kdebase-1.1.2-fixtar.patch
Patch12: konsole-escseqs.patch
Patch100: kdebase-1.1.2-mipscross-niisi.patch 
Group: User Interface/Desktops
Copyright: GPL
BuildRoot: /var/tmp/%{kdename}-buildroot
Requires: kdesupport kdelibs >= 1.1.2-15 tar >= 1.13
%if %{_arch} == %{_build_arch}
BuildPrereq: kdelibs-devel >= 1.1.2-15 qt1x-devel
%endif
Prefix: /usr
%define kdeprefix /usr

%description
The K Desktop Environment (KDE) is a GUI desktop for the X Window
System. The kdebase package contains the core applications for KDE:
kdm, a replacement for xdm (an X display manager); kwm, a KDE window
manager; kfm, a file manager, Web browser, FTP client, etc.; konsole,
an xterm replacement; kpanel, an application starter and desktop
pager; kaudio, an audio server; kdehelp, a viewer for KDE help files,
info and man pages; plus other KDE components (kcheckpass, kikbd, kvt,
kscreensaver, kcontrol, kfind, kfontmanager, kmenuedit, and
kappfinder).

If you want to use KDE, you'll need to install kdebase, kdelibs and
kdesupport. You may also want to install the other KDE packages:
kdeadmin, kdegames, kdegraphics, kdemultimedia, kdenetwork,
kdesupport, and kdeutils.

%package lowcolor-icons
Summary: Low color (8-bit display friendly) icons for KDE.
Group: User Interface/Desktops
Requires: kdebase

%description lowcolor-icons
The default icons in K Desktop Environment (KDE) version 1.1.2 are
color intensive, and can quickly use up all available colors on an
8-bit (256 color) display.  If you have such a display and you're
using KDE, you should install this package, because it will provide a
more efficient allocation of colors when KDE displays icons.

%package 3d-screensavers
Summary: 3-D (OpenGL) screensavers for the K Desktop Environment.
Group: User Interface/Desktops
Requires: kdebase, qt1x-GL, Mesa
BuildPrereq: qt1x-GL, qt1x-devel, Mesa-devel

%description 3d-screensavers
3-D (OpenGL) screensavers for the K Desktop Environment (KDE).

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n kdebase
%patch0 -p1 -b .redhat
%patch1 -p1 -b .waitkdm
%patch2 -p1 -b .dodesktop
%patch3 -p1 -b .saveoption
%patch4 -p1 -b .enablepng
%patch5 -p1 -b .bigendian
%patch6 -p1 -b .glxmesa
%patch7 -p1 -b .eject
%patch8 -p1 -b .kfm-dir
%patch9 -p1 -b .fixdebug
%patch10 -p1 -b .boolterm
%patch11 -p1 -b .fixtar
%patch12 -p1 -b .esc
%patch100 -p1 -b .niisi

%build
#HACK
export KDEDIR=%{__includedir}/kde QTDIR=%{__libdir}/qt-1.45
#QTDIR=%{qtdir}
export ac_cv_prog_cxx_cross=yes
export ac_cv_prog_cc_cross=yes
export cross_compiling=yes
export CC=%{__cc}
export ac_cv_prog_CXX=%{__cxx}
export ac_cv_prog_cc_cross=yes
export ac_cv_prog_cxx_cross=yes
export MOC=/usr/lib/qt-1.45/bin/moc
# this paths are not default (--disbale-path-check) 
export kde_cgidir=/usr/lib/cgi-bin
export kde_htmldir=/usr/doc/kde/HTML
#HACK: add -D_GNU_SOURCE to CXXFLAGS
#end HACK
make -f Makefile.cvs
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS -DNO_DEBUG -DNDEBUG -D_GNU_SOURCE" \
	./configure  \
	--prefix=%{__prefixdir} \
	--with-pam=kde \
	--disable-path-check \
	--with-install-root=$RPM_BUILD_ROOT  \
	--with-gl \
        --host=mips-unknown-linux-gnu \
        --target=mips-unknown-linux-gnu \
	--includedir=%{__includedir} \
	--with-qt-includes==%{__includedir} \
	--libdir=%{__libdir} \
	--x-includes=%{__includedir} \
        --x-libraries=%{__libdir}
make

# set up locolor icons
cd pics
tar xzf locolor-icons.tar.gz

%install
#HACK
export KDEDIR=$RPM_BUILD_ROOT/usr QTDIR=%{__libdir}/qt-1.45
#QTDIR=%{qtdir}
export ac_cv_prog_cxx_cross=yes
export ac_cv_prog_cc_cross=yes
export cross_compiling=yes
export CC=%{__cc}
export ac_cv_prog_CXX=%{__cxx}
export ac_cv_prog_cc_cross=yes
export ac_cv_prog_cxx_cross=yes
export MOC=/usr/lib/qt-1.45/bin/moc
make -f Makefile.cvs
	./configure  \
        --prefix=$RPM_BUILD_ROOT/%{kdeprefix} \
        --with-pam=kde \
        --disable-path-check \
        --with-install-root=$RPM_BUILD_ROOT  \
        --with-gl \
        --host=mips-unknown-linux-gnu \
        --target=mips-unknown-linux-gnu \
        --includedir=$RPM_BUILD_ROOT/include \
        --with-qt-includes==%{__includedir} \
	--x-libraries=$RPM_BUILD_ROOT/usr/X11R6/lib \
        --libdir=$RPM_BUILD_ROOT/usr/lib 

#end HACK
make RUN_KAPPFINDER=no install
# HACK
#
#find $RPM_BUILD_ROOT%{kdeprefix} -type -f -exec strip {} || : \; &>/dev/null
find $RPM_BUILD_ROOT%{kdeprefix} -type f -exec %{__strip} {} || : ';' &>/dev/null
#
#install lowcolor icons
# end hack
mkdir -p $RPM_BUILD_ROOT/usr/share/icons/locolor
cp pics/share/icons/* $RPM_BUILD_ROOT/usr/share/icons/locolor

# do NOT make kvt suid root
chmod 0755 $RPM_BUILD_ROOT/usr/bin/kvt

# make kcheckpass suid root
chmod 1755 $RPM_BUILD_ROOT/usr/bin/kcheckpass

# remove SUID bit from konsole_grantpty
chmod 0755 $RPM_BUILD_ROOT/usr/bin/konsole_grantpty

#install pam configuration file
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -c -m 0644 $RPM_BUILD_DIR/kdebase/kde.pamd \
	$RPM_BUILD_ROOT/etc/pam.d/%{pamservice}

cat >$RPM_BUILD_ROOT/usr/bin/kfmbrowser <<EOF
#!/bin/sh
exec /usr/bin/kfmclient openURL \$*
EOF
chmod 0755 $RPM_BUILD_ROOT/usr/bin/kfmbrowser

# fix kappfinder script for relocatability
{
	pushd $RPM_BUILD_ROOT/usr/bin
	sed -e 's.\$(prefix).\$KDEDIR.g' kappfinder > kappfinder.temp
	sed -e 's.\$INSTPATH./usr.g' kappfinder.temp >kappfinder
	sed -e 's.\${install_root}..g' kappfinder > kappfinder.temp
	mv -f kappfinder.temp kappfinder
	chmod 0755 ./kappfinder
	popd
}

# make symlink for our applnk directory and GNOME directory
{
	pushd $RPM_BUILD_ROOT/usr/share/applnk
	mkdir -p $RPM_BUILD_ROOT/etc/X11/applnk
	cat > $RPM_BUILD_ROOT/etc/X11/applnk/.directory << EOF
# KDE Config File
[KDE Desktop Entry]
Icon=/usr/share/pixmaps/redhat/shadowman-round-32.xpm
MiniIcon=/usr/share/pixmaps/redhat/shadowman-round-mini.xpm
Name=Red Hat
EOF

	ln -sf ../../../etc/X11/applnk redhat

	mkdir -p $RPM_BUILD_ROOT/usr/share/gnome/apps
	cat > $RPM_BUILD_ROOT/usr/share/gnome/apps/.directory << EOF
# KDE Config File
[KDE Desktop Entry]
Icon=/usr/share/pixmaps/gnome-logo-icon-transparent.png
Name=GNOME
EOF
	
	ln -sf ../gnome/apps gnome

	popd
}

# menu layout changes
{
	pushd $RPM_BUILD_ROOT/usr/share/applnk
	mv Krefresh.kdelnk Kfind.kdelnk Trash.kdelnk Utilities/
	popd
}

# fix konsole /opt/kde hardcode
{
	pushd konsole/other
	perl -pi -e "s|/opt/kde|/usr|g" *
	popd
}


# remove some icons that conflict with fvwm2-icons
rm $RPM_BUILD_ROOT/usr/share/icons/bell.xpm
rm $RPM_BUILD_ROOT/usr/share/icons/mini/mini.*

{
	pushd $RPM_BUILD_ROOT
	find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{kdename}

	find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config|' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}

	find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}

	egrep -v "locolor|kmorph3d.kss|kspace.kss|kpipes.kss|pam.d/kde" $RPM_BUILD_DIR/file.list.%{kdename} > \
		$RPM_BUILD_DIR/file.list.%{kdename}.temp
	mv $RPM_BUILD_DIR/file.list.%{kdename}.temp \
		$RPM_BUILD_DIR/file.list.%{kdename}

	echo "%docdir /usr/doc/kde" >> \
		$RPM_BUILD_DIR/file.list.%{kdename}

	popd
}

# install gdm session support
mkdir -p $RPM_BUILD_ROOT/etc/X11/gdm/Sessions
install -c -m 755 %{SOURCE1} \
	$RPM_BUILD_ROOT/etc/X11/gdm/Sessions/KDE

mkdir -p $RPM_BUILD_ROOT/etc/skel/Desktop/Autostart
install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/skel/Desktop/Autostart

# install the linux console fonts
install -d -m 755 $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc
install -c -m 644 konsole/other/*.pcf.gz \
	$RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc



#Remove perl 
%if %{_with_perl} == 0
cp   $RPM_BUILD_DIR/file.list.%{kdename} $RPM_BUILD_DIR/file.list.%{kdename}.tmp
grep -v '\/unpack$' $RPM_BUILD_DIR/file.list.%{kdename}.tmp >$RPM_BUILD_DIR/file.list.%{kdename}
%endif

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/files.list.%{kdename}

%post
cd /usr/X11R6/lib/X11/fonts/misc && mkfontdir

%postun
if [ "$1" = "0" ]; then
  cd /usr/X11R6/lib/X11/fonts/misc && mkfontdir
fi

%files -f ../file.list.%{kdename}
%defattr(-,root,root)
%dir /usr
%dir /usr/X11R6
%dir /usr/X11R6/lib
%dir /usr/X11R6/lib/X11
%dir /usr/X11R6/lib/X11/fonts
%dir /usr/X11R6/lib/X11/fonts/misc
%attr(-,root,root) /etc/X11/gdm/Sessions/KDE
%attr(-,root,root) /usr/X11R6/lib/X11/fonts/misc/*
%config /etc/pam.d/kde

%files lowcolor-icons
/usr/share/icons/locolor

%files 3d-screensavers
%{_prefix}/bin/kmorph3d.kss
%{_prefix}/bin/kspace.kss
%{_prefix}/bin/kpipes.kss

%changelog
* Mon Dec 22 2003 Sergey Rogozhkin <rogozhkin@niisi.msk.ru>
- Replace /export/tools/mips-linux/lib by %%{__libdir}
- Replace /export/tools/mips-linux/include by %%{__includedir}

* Wed Dec 17 2003 Sergey Rogozhkin <rogozhkin@niisi.msk.ru>
- Set files owner and group to root.root
- Add _with_perl variable to build w/ perl
 
* Mon Nov 03 2003 Maria Roganovich <bobkova@niisi.msk.ru>
- Set KDEDIR=%%{__includedir}/kde in %%build and KDEDIR=$RPM_BUILD_ROOT/usr in %%install 
- Set MOC=/usr/lib/qt-1.45/bin/moc
- Remove kdesupport from BuildPrereq 
- Update release to 37.niisi

* Fri Jun 20 2003 Antony Pavloff <antony@pc77a.cs.msu.su>
- Fix  g++-2.96 SIGSEGV on kdebase/kfm/kiojob.cpp:551 (enum type)
- Fix some headers problems (Patch100)
- Fix a multibyte bug in po/ja/kcontrol.po

* Thu Jun 19 2003 Antony Pavloff <antony@pc77a.cs.msu.su>
- (36.niisi) Fix setting read-only $1 in admin/automoc

* Wed Mar  8 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix security problem: Users with /bin/false as shell could log in with kdm
  (Bug #10055)

* Thu Mar  2 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Don't start kbgndwm before copying settings (Bug #9922)

* Mon Feb 21 2000 Preston Brown <pbrown@redhat.com>
- recompile with proper kde_htmldir.
- really fix konsole keybindings to match xterm / debian keyboard standard.
- re-enable BS sends DEL by default.

* Wed Feb 16 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Current KDE_1_1_BRANCH. This fixes the kdehelp i18n bug.

* Fri Feb 11 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Set default->en symlink for HTML docs (Bug #9363)

* Thu Feb 10 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- current KDE_1_1_BRANCH
- add /usr/bin/kfmbrowser script. This is a shortcut to kfmclient OpenURL, and
  is used by the htmlbrowser script (kde2libs)

* Wed Feb  9 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- fix up and re-enable the boolterm patch
- remove autorun from startkde, put a kdelnk in /etc/skel/Desktop/Autostart
  instead. Makes it easier for an individual user to turn it on/off. 
- require kdelibs >= 1.1.2-13, which adapts readBoolEntry to the needs of
  boolterm
- BuildPrereq kdelibs-devel
- Disable "BS sends DEL" by default; it's better with the current ncurses
  and termcap fixes.

* Mon Feb  7 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix up the fixdebug patch
- Disable the "Terminal= is bool" patch. It breaks too many things right now.

* Sun Feb  6 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix konsole escape sequences (Bug #9161)
- Fix kappfinder (Bug #7765 with additional fixes)

* Fri Feb 04 2000 Preston Brown <pbrown@redhat.com>
- read "Terminal=" entry in desktop entries as a bool value, not a string
- fix kappfinder
- fix tar file browsing

* Thu Feb 03 2000 Preston Brown <pbrown@redhat.com>
- more debug output removed

* Tue Feb 01 2000 Preston Brown <pbrown@redhat.com>
- rebuild to fix glibc dependency issue.

* Mon Jan 24 2000 Preston Brown <pbrown@redhat.com>
- fix :: problem in path when using KDM (#3677)

* Tue Jan 18 2000 Preston Brown <pbrown@redhat.com>
- whoops we weren't applying patch #9.

* Tue Jan 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Use /dev/urandom instead of /dev/random (Bug #8233)

* Mon Jan 17 2000 Preston Brown <pbrown@redhat.com>
- remove some debug output that was done with (s)printf (#5938)
- fix lowcolor icon package (#6809)

* Mon Jan 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add eject and kfmdir patches from Harald Hoyer <harald@redhat.de>
- return the real descriptions the build system messed up

* Fri Jan 14 2000 Bill Nottingham <notting@redhat.com>
- rebuild to fix Mesa dependencies

* Sat Jan  8 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix bug in TryExec handling - kpanel no longer hangs the X server when
  accessing the GNOME menu with recent GNOME versions.

* Fri Jan  7 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- KDE_1_1_BRANCH
- Mark /etc/pam.d/kde as config file (#8242)
- Enable building the GL screensavers (to separate package) now that we
  have glxMesa, fix compilation with glxMesa
- Adapt to 6.2 environment
- remove kdm security fix (now in base, along with others)
- work around makefile bug (install-strip breakage)

* Mon Nov 29 1999 Preston Brown <pbrown@redhat.com>
- kdm security fix
- fix to dodesktop patch so that context menu is correct
- fix TryExec (#5454)

* Tue Oct 12 1999 Preston Brown <pbrown@redhat.com>
- use /proc/devices for sound support discovery

* Sun Oct 10 1999 Matt Wilson <msw@redhat.com>
- included patch for sound on big endian machines from Dave Miller

* Mon Sep 27 1999 Preston Brown <pbrown@redhat.com>
- fix check for /etc/sysconfig/soundcard in startkde

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- clean up files in /tmp from startkde
- mark doc files as such

* Tue Sep 21 1999 Preston Brown <pbrown@redhat.com>
- start autorun if present in startkde
- check for configured soundcard before running sound services

* Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
- made kdelnks display Name property if they are of type Link

* Thu Sep 16 1999 Preston Brown <pbrown@redhat.com>
- moved png handling here (from kdelibs)
- changed low color icon directory name to locolor

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- added optional session management to logout dialog
- include GNOME menus

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- added link to /etc/X11/applnk, .directory file
- included lowcolor icon sub-package
- enable .desktop file access

* Fri Sep 10 1999 Preston Brown <pbrown@redhat.com>
- customized startkde script to set up user environment if not present.
- mention kthememgr in description.

* Wed Sep 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.1.2 release
- kvt is back
- kde icon included
- linux console fonts included

* Thu Jul 15 1999 Preston Brown <pbrown@redhat.com>
- PAM console logout problem solved.

* Mon Jul 12 1999 Preston Brown <pbrown@redhat.com>
- now includes screensaver password security fix

* Fri Jun 11 1999 Preston Brown <pbrown@redhat.com>
- snapshot, includes kde 1.1.1 + fixes
- kvt removed for security reasons.  It is a steaming pile of...

* Mon Apr 19 1999 Preston Brown <pbrown@redhat.com>
- last snapshot before release

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- today's snapshot makes kfm a bit nicer and some other fixes
- moved default rc files to kdesupport

* Thu Apr 15 1999 Preston Brown <pbrown@redhat.com>
- SUID bit removed from konsole_grantpty -- not needed w/glibc 2.1

* Wed Apr 14 1999 Preston Brown <pbrown@redhat.com>
- built with today's snapshot -- had to rebuild to fix pam problems.

* Tue Apr 13 1999 Preston Brown <pbrown@redhat.com>
- new snapshot fixes mimetype video/x-flic problem

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- latest stable snapshot

* Fri Apr 09 1999 Preston Brown <pbrown@redhat.com>
- removed bell.xpm (used to be in fvwm2-icons, don't want installer to see
- this previous connection and autoselect kdebase for upgrade).

* Tue Mar 23 1999 Preston Brown <pbrown@redhat.com>
- moved gdm patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- added gdm session control file

* Fri Mar 19 1999 Preston Brown <pbrown@redhat.com>
- added pam-console stuff to kde pam file

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Mon Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgraded to KDE 1.1 final.

* Tue Jan 19 1999 Preston Brown <pbrown@redhat.com>
- updated macros for RPM 3.0, removed red hat logo.

* Tue Jan 05 1999 Preston Brown <pbrown@redhat.com>
- re-merged from Duncan Haldane's stuff
